
# On-screen message

import os
import pygame.font
from mediator import mediator

DEFAULT_MSG_COLOUR = (255,255,255)

message = None

class Message(pygame.sprite.Sprite):
    def __init__(self, font):
        pygame.sprite.Sprite.__init__(self)
        self.font = font
        self.rect = pygame.Rect(30, 550, 0, 0)
        self.display("")
    
    def display(self, messageTxt, colour=DEFAULT_MSG_COLOUR):
        if (not messageTxt):
            messageTxt = " "
        text = self.font.render(messageTxt, True, colour)
        shadow = self.font.render(messageTxt, True, (0,0,0))
        surf = (pygame.surface.Surface(text.get_rect().inflate(2,2).size)
            .convert_alpha())
        surf.fill((0,0,0,0))
        surf.blit(shadow, (2,2))
        surf.blit(text, (0,0))
        self.image = surf
        self.rect.size = self.image.get_size()

if (pygame.font):
    font = pygame.font.Font(os.path.join('data','teenbold.ttf'), 26)
    message = Message(font)
    
    def changeMessageOnTurnEvent(event):
        if (event.turnType == 'terraform'):
            message.display(
                event.player.name + ", terraform your terrain.", 
                event.player.colour)
        elif (event.turnType == 'plan_attack'):
            message.display(
                event.player.name + ", plan your attack!",
                event.player.colour)
        elif (event.turnType == 'attack'):
            message.display(
                event.player.name + ", throw some twisters.",
                event.player.colour)
    mediator.addListener('turn_start', changeMessageOnTurnEvent)
    
    def changeMessageOnGameEnd(event):
        if (event.winner):
            message.display(
                event.winner.name + " WINS THE GAME!",
                event.winner.colour)
        else:
            message.display("Everybody died! Game over.")
    mediator.addListener('game_over', changeMessageOnGameEnd)
    
    message.display("Welcome to Wind Gods.")
