class ColourManager:
    
    colours = [
        # Grey
        (250, 250, 250),
        # Brown
        (200, 150, 50),
        # Green 
        (50, 150, 50),
        # Dark Green
        (0, 50, 50),
        # Black
        (0, 0, 0)
    ]

    """White is the top, down through Greens, to a deep blue at the bottom"""
    def get_level_colour(level):
        colours = ColourManager.colours
        if(level == 0):
            return colours[2]
        elif(level >= 100):
            return colours[0]
        elif(level < 100 and level > 50):
            return ColourManager.colour_merge(colours[0], colours[1], level - 50)
        elif(level <= 50 and level >= 0):
            return ColourManager.colour_merge(colours[1], colours[2], level)
        elif(level < 0 and level > -50):
            return ColourManager.colour_merge(colours[3], colours[2], -level)
        elif(level <= -50 and level > -100):
            return ColourManager.colour_merge(colours[3], colours[4], 100 + level)
        elif(level <= -100):
            return colours[4]                            
    get_level_colour = staticmethod(get_level_colour)
    
    """Gives you a colour somewhere between first and second, how far is [0,50]"""
    def colour_merge(first, second, how_far):
        scale = how_far / 50.0
        red = ColourManager.get_pixel(first[0], second[0], scale)
        green = ColourManager.get_pixel(first[1], second[1], scale)
        blue = ColourManager.get_pixel(first[2], second[2], scale)
        return (int(red), int(green), int(blue))
    colour_merge = staticmethod(colour_merge)
    
    def get_pixel(first, second, scale):
        gap = second - first
        how_far = gap * scale
        return second - how_far
        
    get_pixel = staticmethod(get_pixel)
        